// Code generated by sdkgen. DO NOT EDIT.

// nolint
package elasticsearch

import (
	"context"

	"google.golang.org/grpc"

	elasticsearch "github.com/yandex-cloud/go-genproto/yandex/cloud/mdb/elasticsearch/v1"
	"github.com/yandex-cloud/go-genproto/yandex/cloud/operation"
)

//revive:disable

// ExtensionServiceClient is a elasticsearch.ExtensionServiceClient with
// lazy GRPC connection initialization.
type ExtensionServiceClient struct {
	getConn func(ctx context.Context) (*grpc.ClientConn, error)
}

// Create implements elasticsearch.ExtensionServiceClient
func (c *ExtensionServiceClient) Create(ctx context.Context, in *elasticsearch.CreateExtensionRequest, opts ...grpc.CallOption) (*operation.Operation, error) {
	conn, err := c.getConn(ctx)
	if err != nil {
		return nil, err
	}
	return elasticsearch.NewExtensionServiceClient(conn).Create(ctx, in, opts...)
}

// Delete implements elasticsearch.ExtensionServiceClient
func (c *ExtensionServiceClient) Delete(ctx context.Context, in *elasticsearch.DeleteExtensionRequest, opts ...grpc.CallOption) (*operation.Operation, error) {
	conn, err := c.getConn(ctx)
	if err != nil {
		return nil, err
	}
	return elasticsearch.NewExtensionServiceClient(conn).Delete(ctx, in, opts...)
}

// Get implements elasticsearch.ExtensionServiceClient
func (c *ExtensionServiceClient) Get(ctx context.Context, in *elasticsearch.GetExtensionRequest, opts ...grpc.CallOption) (*elasticsearch.Extension, error) {
	conn, err := c.getConn(ctx)
	if err != nil {
		return nil, err
	}
	return elasticsearch.NewExtensionServiceClient(conn).Get(ctx, in, opts...)
}

// List implements elasticsearch.ExtensionServiceClient
func (c *ExtensionServiceClient) List(ctx context.Context, in *elasticsearch.ListExtensionsRequest, opts ...grpc.CallOption) (*elasticsearch.ListExtensionsResponse, error) {
	conn, err := c.getConn(ctx)
	if err != nil {
		return nil, err
	}
	return elasticsearch.NewExtensionServiceClient(conn).List(ctx, in, opts...)
}

type ExtensionIterator struct {
	ctx  context.Context
	opts []grpc.CallOption

	err           error
	started       bool
	requestedSize int64
	pageSize      int64

	client  *ExtensionServiceClient
	request *elasticsearch.ListExtensionsRequest

	items []*elasticsearch.Extension
}

func (c *ExtensionServiceClient) ExtensionIterator(ctx context.Context, req *elasticsearch.ListExtensionsRequest, opts ...grpc.CallOption) *ExtensionIterator {
	var pageSize int64
	const defaultPageSize = 1000
	pageSize = req.PageSize
	if pageSize == 0 {
		pageSize = defaultPageSize
	}
	return &ExtensionIterator{
		ctx:      ctx,
		opts:     opts,
		client:   c,
		request:  req,
		pageSize: pageSize,
	}
}

func (it *ExtensionIterator) Next() bool {
	if it.err != nil {
		return false
	}
	if len(it.items) > 1 {
		it.items[0] = nil
		it.items = it.items[1:]
		return true
	}
	it.items = nil // consume last item, if any

	if it.started && it.request.PageToken == "" {
		return false
	}
	it.started = true

	if it.requestedSize == 0 || it.requestedSize > it.pageSize {
		it.request.PageSize = it.pageSize
	} else {
		it.request.PageSize = it.requestedSize
	}

	response, err := it.client.List(it.ctx, it.request, it.opts...)
	it.err = err
	if err != nil {
		return false
	}

	it.items = response.Extensions
	it.request.PageToken = response.NextPageToken
	return len(it.items) > 0
}

func (it *ExtensionIterator) Take(size int64) ([]*elasticsearch.Extension, error) {
	if it.err != nil {
		return nil, it.err
	}

	if size == 0 {
		size = 1 << 32 // something insanely large
	}
	it.requestedSize = size
	defer func() {
		// reset iterator for future calls.
		it.requestedSize = 0
	}()

	var result []*elasticsearch.Extension

	for it.requestedSize > 0 && it.Next() {
		it.requestedSize--
		result = append(result, it.Value())
	}

	if it.err != nil {
		return nil, it.err
	}

	return result, nil
}

func (it *ExtensionIterator) TakeAll() ([]*elasticsearch.Extension, error) {
	return it.Take(0)
}

func (it *ExtensionIterator) Value() *elasticsearch.Extension {
	if len(it.items) == 0 {
		panic("calling Value on empty iterator")
	}
	return it.items[0]
}

func (it *ExtensionIterator) Error() error {
	return it.err
}

// Update implements elasticsearch.ExtensionServiceClient
func (c *ExtensionServiceClient) Update(ctx context.Context, in *elasticsearch.UpdateExtensionRequest, opts ...grpc.CallOption) (*operation.Operation, error) {
	conn, err := c.getConn(ctx)
	if err != nil {
		return nil, err
	}
	return elasticsearch.NewExtensionServiceClient(conn).Update(ctx, in, opts...)
}
