// Code generated by sdkgen. DO NOT EDIT.

// nolint
package mysql

import (
	"context"

	"google.golang.org/grpc"

	mysql "github.com/yandex-cloud/go-genproto/yandex/cloud/mdb/mysql/v1"
	"github.com/yandex-cloud/go-genproto/yandex/cloud/operation"
)

//revive:disable

// UserServiceClient is a mysql.UserServiceClient with
// lazy GRPC connection initialization.
type UserServiceClient struct {
	getConn func(ctx context.Context) (*grpc.ClientConn, error)
}

// Create implements mysql.UserServiceClient
func (c *UserServiceClient) Create(ctx context.Context, in *mysql.CreateUserRequest, opts ...grpc.CallOption) (*operation.Operation, error) {
	conn, err := c.getConn(ctx)
	if err != nil {
		return nil, err
	}
	return mysql.NewUserServiceClient(conn).Create(ctx, in, opts...)
}

// Delete implements mysql.UserServiceClient
func (c *UserServiceClient) Delete(ctx context.Context, in *mysql.DeleteUserRequest, opts ...grpc.CallOption) (*operation.Operation, error) {
	conn, err := c.getConn(ctx)
	if err != nil {
		return nil, err
	}
	return mysql.NewUserServiceClient(conn).Delete(ctx, in, opts...)
}

// Get implements mysql.UserServiceClient
func (c *UserServiceClient) Get(ctx context.Context, in *mysql.GetUserRequest, opts ...grpc.CallOption) (*mysql.User, error) {
	conn, err := c.getConn(ctx)
	if err != nil {
		return nil, err
	}
	return mysql.NewUserServiceClient(conn).Get(ctx, in, opts...)
}

// GrantPermission implements mysql.UserServiceClient
func (c *UserServiceClient) GrantPermission(ctx context.Context, in *mysql.GrantUserPermissionRequest, opts ...grpc.CallOption) (*operation.Operation, error) {
	conn, err := c.getConn(ctx)
	if err != nil {
		return nil, err
	}
	return mysql.NewUserServiceClient(conn).GrantPermission(ctx, in, opts...)
}

// List implements mysql.UserServiceClient
func (c *UserServiceClient) List(ctx context.Context, in *mysql.ListUsersRequest, opts ...grpc.CallOption) (*mysql.ListUsersResponse, error) {
	conn, err := c.getConn(ctx)
	if err != nil {
		return nil, err
	}
	return mysql.NewUserServiceClient(conn).List(ctx, in, opts...)
}

type UserIterator struct {
	ctx  context.Context
	opts []grpc.CallOption

	err           error
	started       bool
	requestedSize int64
	pageSize      int64

	client  *UserServiceClient
	request *mysql.ListUsersRequest

	items []*mysql.User
}

func (c *UserServiceClient) UserIterator(ctx context.Context, req *mysql.ListUsersRequest, opts ...grpc.CallOption) *UserIterator {
	var pageSize int64
	const defaultPageSize = 1000
	pageSize = req.PageSize
	if pageSize == 0 {
		pageSize = defaultPageSize
	}
	return &UserIterator{
		ctx:      ctx,
		opts:     opts,
		client:   c,
		request:  req,
		pageSize: pageSize,
	}
}

func (it *UserIterator) Next() bool {
	if it.err != nil {
		return false
	}
	if len(it.items) > 1 {
		it.items[0] = nil
		it.items = it.items[1:]
		return true
	}
	it.items = nil // consume last item, if any

	if it.started && it.request.PageToken == "" {
		return false
	}
	it.started = true

	if it.requestedSize == 0 || it.requestedSize > it.pageSize {
		it.request.PageSize = it.pageSize
	} else {
		it.request.PageSize = it.requestedSize
	}

	response, err := it.client.List(it.ctx, it.request, it.opts...)
	it.err = err
	if err != nil {
		return false
	}

	it.items = response.Users
	it.request.PageToken = response.NextPageToken
	return len(it.items) > 0
}

func (it *UserIterator) Take(size int64) ([]*mysql.User, error) {
	if it.err != nil {
		return nil, it.err
	}

	if size == 0 {
		size = 1 << 32 // something insanely large
	}
	it.requestedSize = size
	defer func() {
		// reset iterator for future calls.
		it.requestedSize = 0
	}()

	var result []*mysql.User

	for it.requestedSize > 0 && it.Next() {
		it.requestedSize--
		result = append(result, it.Value())
	}

	if it.err != nil {
		return nil, it.err
	}

	return result, nil
}

func (it *UserIterator) TakeAll() ([]*mysql.User, error) {
	return it.Take(0)
}

func (it *UserIterator) Value() *mysql.User {
	if len(it.items) == 0 {
		panic("calling Value on empty iterator")
	}
	return it.items[0]
}

func (it *UserIterator) Error() error {
	return it.err
}

// RevokePermission implements mysql.UserServiceClient
func (c *UserServiceClient) RevokePermission(ctx context.Context, in *mysql.RevokeUserPermissionRequest, opts ...grpc.CallOption) (*operation.Operation, error) {
	conn, err := c.getConn(ctx)
	if err != nil {
		return nil, err
	}
	return mysql.NewUserServiceClient(conn).RevokePermission(ctx, in, opts...)
}

// Update implements mysql.UserServiceClient
func (c *UserServiceClient) Update(ctx context.Context, in *mysql.UpdateUserRequest, opts ...grpc.CallOption) (*operation.Operation, error) {
	conn, err := c.getConn(ctx)
	if err != nil {
		return nil, err
	}
	return mysql.NewUserServiceClient(conn).Update(ctx, in, opts...)
}
